package it.mice.voila.runtime.infobar;

import java.util.Collection;

/**
 * Interface for the infobar functionality.
 */
public interface InfoBarManager {
	/**
	 * Implementation must return a Collection of String representing each a message to display to the user in the info bar.
	 * @return Collection of String representing each a message to display to the user in the info bar
	 */
	Collection<String> getMessageList();

	/**
	 * Indicate that a message reporting remaining time to the session expiration must be show to the user in the info bar.
	 * @return true=a message reporting remaining time to the session expiration must be show to the user in the info bar
	 */
	public boolean isIncludeSessionTimeoutMessage();

	/**
	 * Indicate that a message reporting current logged in user name and their profiles must be show to the user in the info bar.
	 * @return true=a message reporting current logged in user name and their profiles must be show to the user in the info bar
	 */
	public boolean isIncludeUserInfoMessage();
}
