/**
 * Licensed under the MICE s.r.l.
 * End User License Agreement
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.micegroup.it/voila/license.html
 */
package it.mice.voila.runtime.util;

/**
 * Extension of the UserMessage that support field error in the middle layer.
 */
public class UserFieldMessage extends UserMessage {
	
    /**
	 * serial version UID
	 */
	private static final long serialVersionUID = -4769151668326993215L;
    /**
     * Build a field error message.
     * @param msgKey the message key.
     * @param fieldPath the field path in error.
     * @param args array of arguments.
     */
    public UserFieldMessage(String msgKey, String fieldPath, Object... args) {
    	super(msgKey, args);
    	setFieldPath(fieldPath);
    }
}
