dojo.addOnLoad(function() {
	activateMceInternal("textareas", null, "mceReadonly", "read");
	activateMceInternal("textareas", null, "mceEditor", "edit");
});

function activateMce(id, btnConfig, btn) {
	activateMceInternal("exact", id, null, btnConfig);
	if (btn)
		btn.style.display = "none";
	return false;
}

function activateMceInternal(mode, elements, selector, btnConfig) {
	if (btnConfig == "read") {
		tinyMCE.init({
			// General options
			mode : mode,
			theme : "advanced",
			content_css : "theme/tiny_mce/word.css",
			readonly : true,
			editor_selector : selector,
			elements : elements,
			entity_encoding : "raw"
		});
	} else if (btnConfig == "editSmall") {
		tinyMCE.init({
			// General options
			mode : mode,
			theme : "advanced",
			editor_selector : selector,
			elements : elements,
			// plugins :
			// "pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,advlist,autosave",
			plugins : "print,contextmenu,paste",
			entity_encoding : "raw",
			
			// Theme options
			theme_advanced_buttons1 : "bold,italic,underline,strikethrough,cut,copy,paste,pastetext,pasteword,undo,redo,justifyleft,justifycenter,justifyright,justifyfull,bullist,numlist",
			theme_advanced_buttons2 : "",
			theme_advanced_buttons3 : "",
			// theme_advanced_buttons3 : "tablecontrols",
			theme_advanced_toolbar_location : "top",
			theme_advanced_toolbar_align : "left",
			theme_advanced_statusbar_location : "bottom",
			theme_advanced_resizing : true,
			theme_advanced_resizing_use_cookie : false,
		
			// Example content CSS (should be your site CSS)
			content_css : "theme/tiny_mce/word.css",
		
			// Style formats
			style_formats : [
				{title : 'Bold text', inline : 'b'},
				{title : 'Red text', inline : 'span', styles : {color : '#ff0000'}},
				{title : 'Red header', block : 'h1', styles : {color : '#ff0000'}},
				{title : 'Example 1', inline : 'span', classes : 'example1'},
				{title : 'Example 2', inline : 'span', classes : 'example2'},
				{title : 'Table styles'},
				{title : 'Table row 1', selector : 'tr', classes : 'tablerow1'}
			],
		});
	} else {
		tinyMCE.init({
			// General options
			mode : mode,
			theme : "advanced",
			editor_selector : selector,
			elements : elements,
			// plugins :
			// "pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,advlist,autosave",
			plugins : "pagebreak,style,table,save,iespell,inlinepopups,insertdatetime,preview,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,wordcount",
			entity_encoding : "raw",
				
			// Theme options
			theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,cut,copy,paste,pastetext,pasteword,|,undo,redo,|,justifyleft,justifycenter,justifyright,justifyfull,|,bullist,numlist,|,styleselect,formatselect,fontselect,fontsizeselect",
			theme_advanced_buttons2 : "search,replace,outdent,indent,blockquote,link,unlink,anchor,cleanup,code,|,insertdate,inserttime,preview,|,forecolor,backcolor,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,pagebreak,hr,removeformat,visualaid,sub,sup,charmap,print,fullscreen",
			theme_advanced_buttons3 : "",
			// theme_advanced_buttons3 : "tablecontrols",
			theme_advanced_toolbar_location : "top",
			theme_advanced_toolbar_align : "left",
			theme_advanced_statusbar_location : "bottom",
			theme_advanced_resizing : true,
		
			// Example content CSS (should be your site CSS)
			content_css : "theme/tiny_mce/word.css",
		
			// Style formats
			style_formats : [
				{title : 'Bold text', inline : 'b'},
				{title : 'Red text', inline : 'span', styles : {color : '#ff0000'}},
				{title : 'Red header', block : 'h1', styles : {color : '#ff0000'}},
				{title : 'Example 1', inline : 'span', classes : 'example1'},
				{title : 'Example 2', inline : 'span', classes : 'example2'},
				{title : 'Table styles'},
				{title : 'Table row 1', selector : 'tr', classes : 'tablerow1'}
			],
		});
	}
}
